Subject: Re: bug#51385: 29.0.50; PragmataPro wide word ligatures such as [ERR] having the left side cut off in cairo build

From: "Patrick Lenihan [sc17pl]" <[email-masked]>
Date: Wed, 3 Nov 2021 18:26:55 +0000

These codepoints correspond to ligatures intended to highlight import messages in command line like [FIXME], [TODO], [WARNING], #FIXME #TODO #ERROR, and their ligatures are a bit wide. These can be viewed on the font authors website at https://fsd.it/wp-content/uploads/command_line_messages_ligatures.png, or on the font authors Github at https://github.com/fabrizioschiavi/pragmatapro/blob/master/showcase/PragmataPro%200.829/PragmataPro-0829-ligatures.png. I found the code points at https://github.com/fabrizioschiavi/pragmatapro/blob/master/emacs_snippets/pragmatapro-prettify-symbols-v0.829.el, which is also in the font author's Github.
[https://repository-images.githubusercontent.com/10056929/68a59700-d314-11e9-9fae-babbbabbc40b]<https://github.com/fabrizioschiavi/pragmatapro/blob/master/emacs_snippets/pragmatapro-prettify-symbols-v0.829.el>
pragmatapro/pragmatapro-prettify-symbols-v0.829.el at master · fabrizioschiavi/pragmatapro<https://github.com/fabrizioschiavi/pragmatapro/blob/master/emacs_snippets/pragmatapro-prettify-symbols-v0.829.el>
PragmataPro font is designed to help pros to work better - pragmatapro/pragmatapro-prettify-symbols-v0.829.el at master · fabrizioschiavi/pragmatapro
github.com

[https://fsd.it/wp-content/uploads/command_line_messages_ligatures.png]

You understood me correctly regarding these PUA characters not displaying in the Cairo build. If Emacs doesn't support them at all then perhaps this is a feature request and not a bug. Thanks for your work on Emacs.
________________________________
From: Eli Zaretskii <[email-masked]>
Sent: 03 November 2021 17:17
To: Patrick Lenihan [sc17pl] <[email-masked]>
Cc: [email-masked] <[email-masked]>
Subject: Re: bug#51385: 29.0.50; PragmataPro wide word ligatures such as [ERR] having the left side cut off in cairo build

> From: "Patrick Lenihan [sc17pl]" <[email-masked]>
> Date: Wed, 3 Nov 2021 15:08:55 +0000
>
> It's my ignorance. I am a user of ligature packages but don't know how they communicate with the
> composition table mechanism in Emacs. Perhaps my best effort recipe wasn't a sensible way to display
> ligatures in Emacs.

Why did you use those particular codepoints? where did you see them,
and what glyphs on display they are supposed to show?

> Although my recipe is not well written I do believe there is a bug. The wide PragmataPro ligatures display fine
> in builds without Cairo, but only the right side is displaying if Cairo is included. Its the same for all ligature
> packages I've tried.

I'm not sure I follow: you believe this is a bug because it appears
with Cairo, but not without Cairo?  That's not evidence that there's a
bug in Emacs.  These builds use different libraries to show stuff on
the glass, and each library could have its own peculiarities when PUA
characters are being displayed.

The important part here is that Emacs doesn't currently support
display of PUA characters, even if the default font has glyphs for
those characters.